﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Diagnostics;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;

namespace ExportGridToExcel
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.Dock = DockStyle.Fill;
            this.ultraGrid1.DataSource = InitializeGridDataSource(rows: 10);

            this.ultraGrid1.Rows[0].Activated = true;
             this.ultraGrid1.DisplayLayout.ViewStyleBand = Infragistics.Win.UltraWinGrid.ViewStyleBand.OutlookGroupBy ;
            //  this.ultraGrid1.DisplayLayout.Override.AllowMultiCellOperations = Infragistics.Win.UltraWinGrid.AllowMultiCellOperation.Paste ;
          


            this.ultraGrid1.UseOsThemes = DefaultableBoolean.False;
            this.ultraGrid1.UseAppStyling = false;
            this.ultraGrid1.DisplayLayout.Appearance.FontData.SizeInPoints = 10;//gridFontSize;
           // this.ultraGrid1.DisplayLayout.Appearance.BackColor = colorBase;
            this.ultraGrid1.Layouts.Grid.DisplayLayout.ColumnChooserEnabled = DefaultableBoolean.True;
            this.ultraGrid1.DisplayLayout.AutoFitStyle = AutoFitStyle.None;


           // this.ultraGrid1.DisplayLayout.Bands[0].Override.RowAppearance.BackColor = Color.AliceBlue ;
            this.ultraGrid1.DisplayLayout.Bands[0].Override.RowAlternateAppearance.BackColor = Color.AliceBlue;
            this.ultraGrid1.DisplayLayout.Bands[0].Override.RowAlternateAppearance.ForeColor = Color.AliceBlue;
            this.ultraGrid1.DisplayLayout.Bands[0].Override.RowAppearance.ForeColor = Color.AliceBlue;


            //  grid.DisplayLayout.RowSelectorImages.AddNewRowImage = Image.FromFile("./Images/MinionAddGridRow.ico");

            // grid.DisplayLayout.RowSelectorImages.ActiveAndAddNewRowImage = Image.FromFile("./Images/EditRow.png");


            this.ultraGrid1.DisplayLayout.Override.AddRowCellAppearance.BackColor = Color.LightYellow;
            this.ultraGrid1.DisplayLayout.Override.AddRowCellAppearance.ForeColor = Color.Red;
            this.ultraGrid1.DisplayLayout.GroupByBox.Appearance.BackColor = Color.Red;

            this.ultraGrid1.DisplayLayout.Override.RowSizing = RowSizing.AutoFree;
            this.ultraGrid1.DisplayLayout.GroupByBox.Appearance.BackGradientStyle = GradientStyle.None;
            ////////END Group By Box/////////////
            this.ultraGrid1.DisplayLayout.Override.RowSelectorHeaderStyle = Infragistics.Win.UltraWinGrid.RowSelectorHeaderStyle.ColumnChooserButton;
            ////////BEGIN Header///////////
          //  this.ultraGrid1.DisplayLayout.Override.HeaderAppearance.BackColor = gridHeaderColor;
          //  this.ultraGrid1.DisplayLayout.Override.HeaderAppearance.ForeColor = fontColorBase;
            this.ultraGrid1.DisplayLayout.Override.HeaderAppearance.BackGradientStyle = GradientStyle.None;
            this.ultraGrid1.DisplayLayout.Override.ColumnAutoSizeMode = ColumnAutoSizeMode.AllRowsInBand;
            ////////END Header/////////////

            ////////BEGIN Fixed Header///////////
            this.ultraGrid1.DisplayLayout.Override.FixedHeaderAppearance.BackColor = Color.Red ;
            this.ultraGrid1.DisplayLayout.Override.FixedHeaderAppearance.ForeColor = Color.Yellow ;
            ////////END Fixed Header/////////////

            UltraGridLayout layout = this.ultraGrid1.DisplayLayout;
            UltraGridBand band = layout.Bands[0];
            //if (band.Columns.Exists("ServerName"))
            //{
            //UltraGridColumn column = band.Columns["ServerName"];
            //column.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Button;
            //grid.DisplayLayout.Override.CellButtonAppearance.ImageHAlign = HAlign.Center;
            //grid.DisplayLayout.Override.ButtonStyle = UIElementButtonStyle.Borderless;
            //grid.DisplayLayout.UseFixedHeaders = true;
            //grid.DisplayLayout.Bands[0].Columns["ServerName"].Header.Fixed = true;
            //grid.DisplayLayout.Override.FixedCellSeparatorColor = gridFixedCellSeparator;
            //column.Header.Appearance.Image = Image.FromFile("./Images/SingleEyecon.png");
            //}
            //if (band.Columns.Exists("DriveName"))
            //{
            // UltraGridColumn column = band.Columns["DriveName"];
            // column.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Button;
            //grid.DisplayLayout.Override.CellButtonAppearance.ImageHAlign = HAlign.Center;
            //grid.DisplayLayout.Override.ButtonStyle = UIElementButtonStyle.Borderless;
            //grid.DisplayLayout.UseFixedHeaders = true;
            //grid.DisplayLayout.Bands[0].Columns["DriveName"].Header.Fixed = true;
            //grid.DisplayLayout.Override.FixedCellSeparatorColor = gridFixedCellSeparator;
            //column.Header.Appearance.Image = Image.FromFile("./Images/SingleEyecon.png");
            // }
            this.ultraGrid1.DisplayLayout.PerformAutoResizeColumns(true, PerformAutoSizeType.AllRowsInBand,AutoResizeColumnWidthOptions.All);
            //////BEGIN Filter Row///////////
            this.ultraGrid1.DisplayLayout.Bands[0].Override.RowFilterMode = RowFilterMode.AllRowsInBand;
          //  this.ultraGrid1.DisplayLayout.Bands[0].Override.FilterRowAppearance.Image = Image.FromFile("./Images/Find.png");
            this.ultraGrid1.DisplayLayout.Bands[0].Override.FilterRowAppearance.BackColor = Color.Empty ;
            this.ultraGrid1.DisplayLayout.Bands[0].Override.RowSelectors = DefaultableBoolean.True;
            
            //////END Filter Row/////////////

            //////BEGIN Error Row///////////
            this.ultraGrid1.DisplayLayout.Bands[0].Override.DataErrorRowAppearance.BackGradientStyle = GradientStyle.Default;
            this.ultraGrid1.DisplayLayout.Bands[0].Override.DataErrorRowAppearance.BackColor = Color.Black;
            this.ultraGrid1.DisplayLayout.Bands[0].Override.DataErrorRowAppearance.BackColor2 = Color.Black;
           //this.ultraGrid1.DisplayLayout.Bands[0].Override.DataErrorRowAppearance.Image = gridDataErrorImage;

            this.ultraGrid1.InitializeLayout += UltraGrid1_InitializeLayout;
        }

        private void UltraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            // throw new NotImplementedException();

            e.Layout.Override.AllowMultiCellOperations = AllowMultiCellOperation.All;

           
        }

        private DataTable InitializeGridDataSource(int rows)
        {
            DataTable table = new DataTable("Table1");

            table.Columns.Add("Boolean column", typeof(Boolean));
            table.Columns.Add("Integer column", typeof(Int32));
            table.Columns.Add("DateTime column", typeof(DateTime));
            table.Columns.Add("String column", typeof(String));

          
            for (int i = 0; i < rows; i++)
            {
                DataRow row = table.NewRow();
                  row["Boolean column"] = i % 2 == 0 ? true : false;
                row["Integer column"] = i;
                row["String column"] = "text string" + i;
                 row["DateTime column"] = DateTime.Now;
                table.Rows.Add(row);
            }

            return table;
        }

        
    }
}
